; Warhol rel 0.04
; Created by Graechan
; You will need to install GMIC to run this Scipt
; GMIC can be downloaded from http://sourceforge.net/projects/gmic/files/ 
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Added Alph-to-Logo script
; Rel 0.03 - Added B/G Density setting to Alph-to-Logo script and did Bugfix
; Rel 0.04 - Changed how the Warhol F/G effect is created in the Alph-to-Logo script and added additional options
(define (script-fu-warhol-alpha-to-logo image layer
                                      tint-type
                                      pattern
                                      color
									  gradient
									  fg-density
									  effect-mode
									  effect-opacity
									  contour
									  offx
									  offy
									  blur
									  opacity
                                      bkg-tint
                                      bkg-pattern
                                      bkg-color
									  bkg-gradient
									  bg-density
									  conserve)
							   
	(gimp-image-undo-group-start image)						  

 (let* (
		(width (car (gimp-drawable-width layer)))
        (height (car (gimp-drawable-height layer)))
		(original-width width)
		(original-height height)
		(area (* 1000 1000))
		(alpha (car (gimp-drawable-has-alpha layer)))
		(sel (car (gimp-selection-is-empty image)))
		(layer-name (car (gimp-drawable-get-name layer)))
		(selection-channel 0)
		(selection-bounds 0)
		(bounds-x1 0)
		(bounds-y1 0)
		(bounds-x2 0)
		(bounds-y2 0)
		(bounds-width 0)
		(bounds-height 0)
		(contour-layer 0)
		(contour-channel 0)
		(contour-mask 0)
		(shadow 0)
        )
	
	
	(gimp-context-push)
    (gimp-context-set-default-colors)
	
	(if (= alpha FALSE) (gimp-layer-add-alpha layer))
	
;;;;check that a selection was made if not make one	
	(if (= sel TRUE) (gimp-selection-layer-alpha layer))
	
;;;;create selection-channel (gimp-selection-load selection-channel)
	(set! selection-channel (car (gimp-selection-save image)))	
	(gimp-drawable-set-name selection-channel "selection-channel")
    (gimp-image-set-active-layer image layer)	

;;;;begin the script;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;;;;clean the image
    (gimp-selection-invert image)
	(gimp-edit-clear layer)
	(gimp-selection-invert image)
;    (gimp-edit-fill layer FOREGROUND-FILL)

;;;;find the selection co-ordinates	
	(set! selection-bounds (cdr (gimp-selection-bounds image)))
	(set! bounds-x1 (car selection-bounds));x coordinate of upper left corner of selection bounds
    (set! bounds-y1 (cadr selection-bounds));y coordinate of upper left corner of selection bounds
    (set! bounds-x2 (caddr selection-bounds));x coordinate of lower right corner of selection bounds
    (set! bounds-y2 (cadddr selection-bounds));y coordinate of lower right corner of selection bounds
	(set! bounds-width (- (caddr selection-bounds) (car selection-bounds)))
	(set! bounds-height (- (cadddr selection-bounds) (cadr selection-bounds)))
	(gimp-selection-none image)
	
; *******************************************Start-[G'MIC] Warhol	
	
			(let*
				(
					;; Matching variables
					(bkg-layer (car (gimp-layer-copy layer TRUE)))                    
				)
		
				;; Add a layer
				(gimp-image-add-layer image bkg-layer (+ (car (gimp-image-get-layer-position image layer)) 1)) ;under
                                
                     
				

                ;[G'MIC] Warhol : -warhol 9,9,0.47,44.24    				
						
				;; Render Warhol using G'MIC.
				(plug-in-gmic 1 image bkg-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-warhol " 
						(number->string bg-density) ","
						(number->string bg-density) ",0.47,44.24"))		
                
				(set! bkg-layer (car (gimp-image-get-active-layer image)))
				
				;; name the layer
				(gimp-drawable-set-name bkg-layer "Background")
				(plug-in-autocrop 1 image bkg-layer)
								
; *******************************************End-[G'MIC] Warhol	
    
    (gimp-context-set-pattern bkg-pattern)
	(gimp-context-set-background bkg-color)
	(gimp-context-set-gradient bkg-gradient)
	(gimp-selection-all image)
	(if (= bkg-tint 1) (gimp-edit-bucket-fill bkg-layer PATTERN-BUCKET-FILL GRAIN-MERGE-MODE 100 15 FALSE 0 0))		
    (if (= bkg-tint 0) (gimp-edit-bucket-fill bkg-layer BG-BUCKET-FILL COLOR-MODE 100 15 FALSE 0 0))	
    (if (= bkg-tint 2) (gimp-edit-blend bkg-layer CUSTOM-MODE COLOR-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width 0))
	(gimp-displays-flush)
	

; *******************************************Start-[G'MIC] Warhol	
	
			(let*
				(
					;; Matching variables
					(warhol-layer (car (gimp-layer-copy layer TRUE)))                    
				)
		
				;; Add a layer
				(gimp-image-add-layer image warhol-layer (car (gimp-image-get-layer-position image layer))) ;over
                                
                     
				(gimp-rect-select image
                        (car (gimp-drawable-offsets warhol-layer))
                        (cadr (gimp-drawable-offsets warhol-layer))
                        width
                        height
						CHANNEL-OP-REPLACE ;operation{ CHANNEL-OP-ADD (0), CHANNEL-OP-SUBTRACT (1), CHANNEL-OP-REPLACE (2), CHANNEL-OP-INTERSECT (3) }
						FALSE ;feather
						10)  ;feather radious

                ;[G'MIC] Warhol : -warhol 3,3,0.47,44.24    				
						
				;; Render Warhol using G'MIC.
				(plug-in-gmic 1 image warhol-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-warhol " 
						(number->string fg-density) ","
						(number->string fg-density) ",0.47,44.24"))	
                
				(set! warhol-layer (car (gimp-image-get-active-layer image)))
				(gimp-layer-set-mode warhol-layer effect-mode) 
				(gimp-layer-set-opacity warhol-layer effect-opacity)
								
				;; name the layer
				(gimp-drawable-set-name warhol-layer "Warhol")
				(gimp-layer-add-alpha warhol-layer)
				;;offset the layer
;				(gimp-layer-set-offsets warhol-layer bounds-x1 bounds-y1)
				(gimp-selection-load selection-channel)
				(gimp-selection-invert image)
				(gimp-edit-clear warhol-layer)
				(gimp-selection-invert image)
;				(gimp-layer-resize-to-image-size warhol-layer)
				
; *******************************************End-[G'MIC] Warhol		
	
	(gimp-context-set-pattern pattern)
	(gimp-context-set-background color)
	(gimp-context-set-gradient gradient)
	(if (= tint-type 1) (gimp-edit-bucket-fill warhol-layer PATTERN-BUCKET-FILL GRAIN-MERGE-MODE 100 15 FALSE 0 0))		
    (if (= tint-type 0) (gimp-edit-bucket-fill warhol-layer BG-BUCKET-FILL COLOR-MODE 100 15 FALSE 0 0))	
    (if (= tint-type 2) (gimp-edit-blend warhol-layer CUSTOM-MODE COLOR-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE bounds-x1 bounds-y1 bounds-x2 bounds-y1))
   	(gimp-displays-flush)

	(if (= contour TRUE) (begin
;;;;create the contour layer
	(set! contour-layer (car (gimp-layer-new image width height RGBA-IMAGE "Contour" 100 NORMAL-MODE)))
    (gimp-image-add-layer image contour-layer 0)
	(gimp-selection-shrink image 4)
	
;;;;create contour-channel (gimp-selection-load contour-channel)
	(set! contour-channel (car (gimp-selection-save image)))
	(gimp-drawable-set-name contour-channel "contour-channel")
	(gimp-image-set-active-layer image contour-layer)
	(gimp-selection-load selection-channel)
	
	(gimp-selection-combine contour-channel 1)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill contour-layer FOREGROUND-FILL)	
	
	(gimp-selection-load selection-channel)
	(gimp-selection-invert image)
	(gimp-edit-clear layer)
	(gimp-edit-clear warhol-layer)
	(gimp-selection-invert image)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image contour-layer 10 10)
	(gimp-layer-resize-to-image-size contour-layer)))
	
;;;;create the shadow
	(gimp-selection-load selection-channel)
	(set! shadow (car (gimp-layer-new image width height RGBA-IMAGE "Drop Shadow" 100 NORMAL-MODE)))
	(gimp-image-add-layer image shadow (+ (car (gimp-image-get-layer-position image layer)) 1)) ;under
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill shadow FOREGROUND-FILL)
	(gimp-selection-none image)
	(gimp-layer-set-offsets shadow offx offy)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image shadow blur blur)
	(gimp-layer-set-opacity shadow opacity)
	(gimp-layer-resize-to-image-size shadow)
	(gimp-selection-load selection-channel)
	(gimp-edit-clear shadow)
	(gimp-selection-none image)
    (gimp-image-set-active-layer image layer)	
	
;;;;finish the script;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	(if (= conserve FALSE) (begin
    (set! layer (car (gimp-image-merge-down image layer EXPAND-AS-NECESSARY)))
	(set! layer (car (gimp-image-merge-down image layer EXPAND-AS-NECESSARY)))
	(set! layer (car (gimp-image-merge-down image warhol-layer EXPAND-AS-NECESSARY)))
	(if (= contour TRUE) (set! layer (car (gimp-image-merge-down image contour-layer EXPAND-AS-NECESSARY))))
    (gimp-drawable-set-name layer layer-name)
	(gimp-image-remove-channel image selection-channel)
	(gimp-image-remove-channel image contour-channel)))
	(if (and (= conserve FALSE) (= alpha FALSE)) (gimp-layer-flatten layer))	

	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)    

 )
 )
 )
)





(define (script-fu-warhol-logo
                                      text
									  letter-spacing
									  line-spacing
                                      color 
                                      font-in 
                                      font-size
									  text-tint
                                      text-pattern
                                      text-color
									  text-gradient
									  offx
									  offy
									  blur
									  opacity
                                      bkg-tint
                                      bkg-pattern
                                      bkg-color
									  bkg-gradient
									  conserve
									  )
  (let* (
        (image (car (gimp-image-new 256 256 RGB)))         
        (border (round (/ font-size 5)))
		(font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
        (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
        (final-width (car (gimp-drawable-width size-layer)))
        (final-height (car (gimp-drawable-height size-layer)))
        (text-layer 0)
        (width 0)
        (height 0)
		(text-channel 0)
		(bkg-layer 0)
		(selection-bounds 0)
		(bounds-x1 0)
		(bounds-y1 0)
		(bounds-x2 0)
		(bounds-y2 0)
		(contour-layer 0)
		(contour-channel 0)
		(contour-mask 0)         
        )
		
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text (round (/ 150 5)) TRUE 150 PIXELS font)))
;;;;adjust text 
	(gimp-text-layer-set-justification text-layer 2)
	(gimp-text-layer-set-letter-spacing text-layer letter-spacing)
	(gimp-text-layer-set-line-spacing text-layer line-spacing)
;;;;set the new width and height	
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
	(gimp-drawable-set-name text-layer "Text")
    (gimp-image-resize-to-layers image)

;;;;set the text clolor    
    (gimp-selection-layer-alpha text-layer)
	(gimp-edit-fill text-layer FOREGROUND-FILL)
;;;;create text-channel (gimp-selection-load text-channel)
	(set! text-channel (car (gimp-selection-save image)))
	(gimp-drawable-set-name text-channel "text-channel")
	(gimp-image-set-active-layer image text-layer)
;;;;find the selection co-ordinates	
	(set! selection-bounds (cdr (gimp-selection-bounds image)))
	(set! bounds-x1 (car selection-bounds));x coordinate of upper left corner of selection bounds
    (set! bounds-y1 (cadr selection-bounds));y coordinate of upper left corner of selection bounds
    (set! bounds-x2 (caddr selection-bounds));x coordinate of lower right corner of selection bounds
    (set! bounds-y2 (cadddr selection-bounds));y coordinate of lower right corner of selection bounds
	(gimp-selection-none image)
	
; *******************************************Start-[G'MIC] Warhol	
	
			(let*
				(
					;; Matching variables
					(bkg-layer (car (gimp-layer-copy text-layer TRUE)))                    
				)
		
				;; Add a layer
				(gimp-image-add-layer image bkg-layer (+ (car (gimp-image-get-layer-position image text-layer)) 1)) ;under
                                
                     
				

                ;[G'MIC] Warhol : -warhol 9,9,0.47,44.24    				
						
				;; Render Warhol using G'MIC.
				(plug-in-gmic 1 image bkg-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-warhol 9,9,0.47,44.24"))	
                
				(set! bkg-layer (car (gimp-image-get-active-layer image)))
				
				;; name the layer
				(gimp-drawable-set-name bkg-layer "Background")
; *******************************************End-[G'MIC] Warhol

	(gimp-context-set-pattern bkg-pattern)
	(gimp-context-set-background bkg-color)
	(gimp-context-set-gradient bkg-gradient)
	(gimp-selection-all image)
	(if (= bkg-tint 1) (gimp-edit-bucket-fill bkg-layer PATTERN-BUCKET-FILL GRAIN-MERGE-MODE 100 15 FALSE 0 0))		
    (if (= bkg-tint 0) (gimp-edit-bucket-fill bkg-layer BG-BUCKET-FILL COLOR-MODE 100 15 FALSE 0 0))	
    (if (= bkg-tint 2) (gimp-edit-blend bkg-layer CUSTOM-MODE COLOR-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width 0))
              
; *******************************************Start-[G'MIC] Warhol	
	
			(let*
				(
					;; Matching variables
					(warhol-layer (car (gimp-layer-copy text-layer TRUE)))                    
				)
		
				;; Add a layer
				(gimp-image-add-layer image warhol-layer (car (gimp-image-get-layer-position image text-layer))) ;over
                                
                     
				(gimp-selection-load text-channel)

                ;[G'MIC] Warhol : -warhol 3,3,0.47,44.24    				
						
				;; Render Warhol using G'MIC.
				(plug-in-gmic 1 image warhol-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-warhol 3,3,0.47,44.24"))	
                
				(set! warhol-layer (car (gimp-image-get-active-layer image)))
								
				;; name the layer
				(gimp-drawable-set-name warhol-layer "Warhol")
				(gimp-layer-add-alpha warhol-layer)
				;;offset the layer
				(gimp-layer-set-offsets warhol-layer bounds-x1 bounds-y1)
				(gimp-selection-load text-channel)
				(gimp-selection-invert image)
				(gimp-edit-clear warhol-layer)
				(gimp-selection-invert image)
				(gimp-layer-resize-to-image-size warhol-layer)
				
; *******************************************End-[G'MIC] Warhol	
	(gimp-context-set-pattern text-pattern)
	(gimp-context-set-background text-color)
	(gimp-context-set-gradient text-gradient)
	(if (= text-tint 1) (gimp-edit-bucket-fill warhol-layer PATTERN-BUCKET-FILL GRAIN-MERGE-MODE 100 15 FALSE 0 0))		
    (if (= text-tint 0) (gimp-edit-bucket-fill warhol-layer BG-BUCKET-FILL COLOR-MODE 100 15 FALSE 0 0))	
    (if (= text-tint 2) (gimp-edit-blend warhol-layer CUSTOM-MODE COLOR-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE bounds-x1 bounds-y1 bounds-x2 bounds-y1))
              
	
	(set! contour-layer (car (gimp-layer-new image width height RGBA-IMAGE "Contour" 100 NORMAL-MODE)))
    (gimp-image-add-layer image contour-layer 0)
	(gimp-selection-shrink image 4)
	
;;;;create contour-channel (gimp-selection-load contour-channel)
	(set! contour-channel (car (gimp-selection-save image)))
	(gimp-drawable-set-name contour-channel "contour-channel")
	(gimp-image-set-active-layer image contour-layer)
	(gimp-selection-load text-channel)
	
	(gimp-selection-combine contour-channel 1)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill contour-layer FOREGROUND-FILL)
	

	(gimp-selection-load text-channel)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image contour-layer 10 10)
	(gimp-selection-none image)

;;;;Scale Image to it's original size;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (gimp-image-scale-full image final-width final-height 2)
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
	
;;;;create the shadow		
    (gimp-image-set-active-layer image text-layer)
	(gimp-layer-set-offsets text-layer offx offy)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image text-layer blur blur)
	(gimp-layer-set-opacity text-layer opacity)
	(gimp-layer-resize-to-image-size text-layer)
	(gimp-drawable-set-name text-layer "Shadow")
	(gimp-selection-load text-channel)
	(gimp-edit-clear text-layer)
	(gimp-selection-none image)
	
	(if (= conserve FALSE) (begin
	(set! text-layer (car (gimp-image-merge-visible-layers image  EXPAND-AS-NECESSARY)))
	(gimp-image-remove-channel image text-channel)
	(gimp-image-remove-channel image contour-channel)
	(gimp-drawable-set-name text-layer text)))

	(gimp-context-pop)
	
    (gimp-display-new image)
	
	)
	)
    )
  )
  







(script-fu-register "script-fu-warhol-alpha-to-logo"
"Warhol..."
"Uses GMIC's Warhol filter to create a image from your layer with alpha background or selection"
"Graechan"
"Graechan - http://gimpchat.com"
"April 2013"
"RGB*"
SF-IMAGE "image" 0
SF-DRAWABLE "drawable" 0
SF-OPTION "Tint Type" '("Color" "Pattern" "Gradient" "None")
SF-PATTERN "Tint Pattern" "Crack"
SF-COLOR "Tint color" '(0 0 255)
SF-GRADIENT "Tint Gradient" "Abstract 2"
SF-ADJUSTMENT "F/G Density" '(3 2 10 1 1 0 1)
SF-ENUM "F/G Effect LayerMode" '("LayerModeEffects" "screen-mode")
SF-ADJUSTMENT "F/G Effect Opacity" '(100 0 100 1 5 0 0)
SF-TOGGLE "Add a Contour" TRUE
SF-ADJUSTMENT "Shadow Offx" '(8 -100 100 1 1 0 1)
SF-ADJUSTMENT "Shadow Offy" '(8 -100 100 1 1 0 1)
SF-ADJUSTMENT "Shadow Blur" '(15 0 500 1 5 0 0)
SF-ADJUSTMENT "Shadow Opacity" '(80 0 100 1 5 0 0)
SF-OPTION "Background Tint" '("Color" "Pattern" "Gradient" "None")
SF-PATTERN "Bkg Tint Pattern" "Bricks"
SF-COLOR "Bkg Tint color" '(0 255 0)
SF-GRADIENT "Bkg Tint Gradient" "Abstract 3"
SF-ADJUSTMENT "B/G Density" '(9 2 10 1 1 0 1)
SF-TOGGLE "Keep the Layers" FALSE
)

(script-fu-register "script-fu-warhol-logo"
"Warhol..."
"Uses GMIC's Warhol filter to create a logo"
"Graechan"
"Graechan - http://gimpchat.com"
"April 2013"
""
SF-TEXT "Text" "WARHOL"
SF-ADJUSTMENT "Letter Spacing" '(0 -100 100 1 5 0 0)
SF-ADJUSTMENT "Line Spacing" '(0 -100 100 1 5 0 0)
SF-COLOR "Text color" '(0 0 0)
SF-FONT "Font" "Sans Bold"
SF-ADJUSTMENT "Font size (pixels)" '(150 6 500 1 1 0 1)
SF-OPTION "Text Tint" '("Color" "Pattern" "Gradient" "None")
SF-PATTERN "Text Tint Pattern" "Crack"
SF-COLOR "Text Tint color" '(0 0 255)
SF-GRADIENT "Text Tint Gradient" "Abstract 2"
SF-ADJUSTMENT "Shadow Offx" '(8 -100 100 1 1 0 1)
SF-ADJUSTMENT "Shadow Offy" '(8 -100 100 1 1 0 1)
SF-ADJUSTMENT "Shadow Blur" '(15 0 500 1 5 0 0)
SF-ADJUSTMENT "Shadow Opacity" '(80 0 100 1 5 0 0)
SF-OPTION "Background Tint" '("Color" "Pattern" "Gradient" "None")
SF-PATTERN "Bkg Tint Pattern" "Bricks"
SF-COLOR "Bkg Tint color" '(0 255 0)
SF-GRADIENT "Bkg Tint Gradient" "Abstract 3"
SF-TOGGLE "Keep the Layers" FALSE
)

(script-fu-menu-register "script-fu-warhol-alpha-to-logo" "<Image>/Filters/Alpha to Logo")

(script-fu-menu-register "script-fu-warhol-logo" "<Image>/File/Create/Logos")
