; Waterdrops Rel. 0.4 Created by graechan
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;    This Script follows an excelent tutorial 
;
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Added iwarp option
; Rel 0.03 - Added selection script located at Script-Fu > Selection Effects 
; Rel 0.04 - Tidied up script and fixed bugs. Changed script locationss to Script-Fu > Logos and Script-Fu > Effects  
;;;;
						 
(define (script-fu-water-drops-text 
                                      img-width
                                      img-height
                                      text                                       
                                      font-in 
                                      font-size
									  grow
                                      bkg-type 
                                      bkg-color
									  pattern
									  warp
									  drop-size
									  shadow-size
							          shadow-opacity
									  conserve)
  (let* (
         (width img-width)
         (height img-height)
         (offx 0)
         (offy 0)
         (image (car (gimp-image-new img-width img-height RGB)))         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (text-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (text-width (car (gimp-drawable-width text-layer)))
         (text-height (car (gimp-drawable-height text-layer)))
         (bkg-layer 0)
		 (selblur-layer 0)
		 (drops-layer 0)
         (activeLayer 0)
		 (img-layer 0)
		 (img-channel 0)
		 (img-layer-bump 0)
		 (shadow-layer 0)
		 (waterdrops-layer 0)
		 (img2-layer 0)
		 )
		 
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
;;;;centre text on line
	(gimp-text-layer-set-justification text-layer 2)
    
;;;;set the new Image size	
	(if (> text-width img-width)
           (begin
    (set! width text-width)
           )
    )
    (if (> text-height img-height)
           (begin
    (set! height text-height)
           )
    )

;;;;square up the Image	
    ;(if (< height width) (set! height width))
	;(if (< width height) (set! width height))
	(gimp-image-resize image width height 0 0)
	
;;;;centre the text layer    
	(set! offx (/ (- width text-width) 2))
    (set! offy (/ (- height text-height) 2))    
    (gimp-image-resize image width height 0 0)
    (gimp-layer-set-offsets text-layer offx offy)

;;;;Expand the font if needed
    (if (> grow 0)
           (begin
    (gimp-selection-layer-alpha text-layer)
    (gimp-edit-clear text-layer)
    (gimp-selection-grow image grow)
    (gimp-context-set-foreground '(0 0 0))
    (gimp-edit-fill text-layer FOREGROUND-FILL)
    (gimp-selection-none image)
           )
    )
	(plug-in-ripple 1 image text-layer 40 5 1 0 1 TRUE FALSE)
;;;;fill the text layer with black    
    (gimp-context-set-foreground '(0 0 0))	
	(gimp-selection-layer-alpha text-layer)
	(gimp-edit-fill text-layer FOREGROUND-FILL)
	(gimp-selection-none image)

;;;;create the background layer    
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 1)
	(gimp-context-set-pattern pattern)
	(gimp-context-set-background bkg-color)
	(if (= bkg-type 0) (gimp-drawable-fill bkg-layer PATTERN-FILL))		
    (if (= bkg-type 1) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))
    (if (= bkg-type 1) (plug-in-grid 1 image bkg-layer 2 30 0 '(0 0 0) 100 2 30 0 '(255 255 255) 100 0 0 0 '(0 0 0) 100))
	
	
;;;;create black text with drops on white background
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(0 0 255))    
	(gimp-image-set-active-layer image text-layer)
	(set! drops-layer (car (gimp-layer-new image width height RGBA-IMAGE "Drops" 100 NORMAL-MODE)))
    (gimp-image-add-layer image drops-layer 1)
	(gimp-drawable-fill drops-layer BACKGROUND-FILL)
	(plug-in-solid-noise RUN-NONINTERACTIVE image drops-layer 0 0 0 1 16 16)
	(gimp-threshold drops-layer drop-size 172)
	(plug-in-colortoalpha RUN-NONINTERACTIVE image drops-layer '(255 255 255))	
	(gimp-context-set-background '(255 255 255))	
	(gimp-selection-layer-alpha text-layer)
	(gimp-selection-grow image 5)
	(gimp-edit-clear drops-layer)
	(gimp-selection-none image)
    (gimp-image-set-active-layer image text-layer)
	(gimp-image-merge-down image text-layer EXPAND-AS-NECESSARY)
	(set! img-layer (car (gimp-image-get-active-layer image)))
	(gimp-drawable-set-name img-layer "img-layer")
	(gimp-selection-layer-alpha img-layer)
	(gimp-edit-fill img-layer BACKGROUND-FILL)

;;;;Iwarp option	
	(gimp-selection-none image)
	(if (= warp TRUE) (plug-in-iwarp 0 image img-layer))
	(gimp-selection-layer-alpha img-layer)
		
;;;;create channel
	(gimp-selection-save image)
	(set! img-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity img-channel 100)	
	(gimp-drawable-set-name img-channel "img-channel")
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image img-channel 15 15)
	
;;;;create the effects
	(gimp-image-set-active-layer image img-layer)
	
	
;;;;LIGHT 1
(plug-in-lighting 1 
	    image              ; IMAGE
		img-layer          ; DRAWABLE
		img-channel        ; BUMP MAP  (set to 0 if disabled)
		0                  ; ENVIRONMENT MAP  (set to 0 if disabled)
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		3                  ; TYPE OF MAPPING (0=linear,1=log, 2=sinusoidal, 3=spherical)
		1                  ; TYPE OF LIGHTSOURCE (0=point,1=directional,3=spot,4=none) 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		-1                 ; LIGHTSOURCE POS X
		-1                 ; LIGHTSOURCE POS Y
		1                  ; LIGHTSOURCE POS Z
		1.87               ; LIGHTSOURCE DIR X
		-1.52              ; LIGHTSOURCE DIR Y
		1                  ; LIGHTSOURCE DIR Z
		0.50               ; AMBIANT INTENSITY (GLOWING)
		0.30               ; DIFFUSE INTENSITY (BRIGHT)
		1                  ; DIFFUSE REFLECTIVITY (INTENSITY)
		0.5                ; SPECULAR REFLECTIVITY (SHINY)
		10                 ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT 

;;;;LIGHT 2
(plug-in-lighting 1 
	    image              ; IMAGE
		img-layer          ; DRAWABLE
		img-channel        ; BUMP MAP (USE '0' IF NOT NEEDED)
		0                  ; ENVIRONMENT MAP (USE '0' IF NOT NEEDED)
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		3                  ; TYPE OF MAPPING (0=linear,1=log, 2=sinusoidal, 3=spherical)
		1                  ; TYPE OF LIGHTSOURCE (0=point,1=directional,3=spot,4=none) 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		2                  ; LIGHTSOURCE POS X
		-1                 ; LIGHTSOURCE POS Y
		1                  ; LIGHTSOURCE POS Z
		-1.57              ; LIGHTSOURCE DIR X
		1.51               ; LIGHTSOURCE DIR Y
		1                  ; LIGHTSOURCE DIR Z
		0.50               ; AMBIANT INTENSITY (GLOWING)
		0.30               ; DIFFUSE INTENSITY (BRIGHT)
		1                  ; DIFFUSE REFLECTIVITY (INTENSITY)
		0.5                ; SPECULAR REFLECTIVITY (SHINY)
		10                 ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT

    		

    (plug-in-colortoalpha RUN-NONINTERACTIVE image img-layer '(135 135 135))              
    (plug-in-blur RUN-NONINTERACTIVE image img-layer)
	(gimp-image-set-active-layer image bkg-layer)
	(plug-in-displace RUN-NONINTERACTIVE image bkg-layer 8 8 TRUE TRUE img-channel img-channel 0)

;;;;create the shadow
(if (> shadow-size 0)
  (begin
    (gimp-context-set-foreground '(0 0 0))  
	(set! shadow-layer (car (gimp-layer-new image width height RGBA-IMAGE "Shadow" shadow-opacity NORMAL-MODE)))
    (gimp-image-add-layer image shadow-layer -1)	
	(gimp-edit-fill shadow-layer FOREGROUND-FILL)
	(gimp-layer-translate shadow-layer shadow-size shadow-size)
	(gimp-layer-resize-to-image-size shadow-layer)
	(gimp-edit-clear shadow-layer)
	(gimp-selection-invert image)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image shadow-layer 10 10)
   )
 )
    (gimp-selection-none image)

    
	
	(if (= conserve FALSE) 
	(begin
	(set! waterdrops-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
    (gimp-drawable-set-name waterdrops-layer "Water Drops")
	)
	) 
	
	(gimp-context-pop)
    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-water-drops-text"
  "Water Drops Text..."
  "Create an image with Text surrounded by Water drops"
  "Graechan"
  "Graechan"
  "February 2012"
  ""
  SF-ADJUSTMENT "Image width (pixels)" '(250 1 1000 1 10 0 1)
  SF-ADJUSTMENT "Image height(pixels)" '(250 1 1000 1 10 0 1)
  SF-TEXT       "Text"    "GIMP\nWATER\nDROPS"  
  SF-FONT       "Font"               "JasmineUPC Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(290 6 500 1 1 0 1)
  SF-ADJUSTMENT "Expand the Font if needed" '(5 0 10 1 1 0 0)
  SF-OPTION "Background Type" '( "Pattern" "Color" "None")
  SF-COLOR      "Tile Color"         '(127 127 127)
  SF-PATTERN    "Pattern"            "Dried mud"
  SF-TOGGLE "iWarp manually (For much better results), it will make the iWarp window pop" FALSE
  SF-ADJUSTMENT "Water drops size" '(120 1 172 1 10 0 0)
  SF-ADJUSTMENT "Shadow Size" '(8 0 16 1 10 0 0)
  SF-ADJUSTMENT "Shadow Opacity" '(100 0 100 1 10 0 0)
  SF-TOGGLE     "Keep the Layers"   FALSE
  )
(script-fu-menu-register "script-fu-water-drops-text"
  "<Image>/File/Create/Logos"
  )
 
;;;;
(define (script-fu-waterdrops image drawable
                               drop-size
							   shadow-size
							   shadow-opacity
							   keep-selection-in
							   conserve)
							  

 (let* (
            (bkg-layer (car (gimp-image-get-active-layer image)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(alpha (car (gimp-drawable-has-alpha bkg-layer)))
			(sel (car (gimp-selection-is-empty image)))
		    (layer-name (car (gimp-drawable-get-name bkg-layer)))
		    (keep-selection keep-selection-in)
			(orig-channel 0)
			;;;;;;;;;;;;;;;;;;;;;;
			(temp-layer 0)
			(selblur-layer 0)
		    (drops-layer 0)
            (img-layer 0)
		    (img-channel 0)
		    (img-layer-bump 0)
		    (shadow-layer 0)
		    (waterdrops-layer 0)
        )

	
	
	(gimp-context-push)
    (gimp-image-undo-group-start image)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
    (if (= alpha FALSE) (gimp-layer-add-alpha bkg-layer))

;;;;check that a selection was made if not make one	
	(if (= sel TRUE) (set! keep-selection FALSE))
	(if (= sel TRUE) (gimp-selection-layer-alpha bkg-layer))	
	
;;;;create channel to save the original selection
	(gimp-selection-shrink image 1)
	(gimp-selection-save image)
	(set! orig-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity orig-channel 100)	
	(gimp-drawable-set-name orig-channel "Orig-channel")
	(gimp-selection-none image)

    (set! temp-layer (car (gimp-layer-new image width height RGBA-IMAGE "temp" 100 NORMAL-MODE)))
    (gimp-image-add-layer image temp-layer -1)

;;;;create black drops on white background
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(0 0 255))    
	(gimp-image-set-active-layer image temp-layer)
	(set! drops-layer (car (gimp-layer-new image width height RGBA-IMAGE "Drops" 100 NORMAL-MODE)))
    (gimp-image-add-layer image drops-layer 1)
	(gimp-drawable-fill drops-layer BACKGROUND-FILL)
	(plug-in-solid-noise RUN-NONINTERACTIVE image drops-layer 0 0 0 1 16 16)
	(gimp-threshold drops-layer drop-size 172)
	(plug-in-colortoalpha RUN-NONINTERACTIVE image drops-layer '(255 255 255))	
	(gimp-context-set-background '(255 255 255))	
	(gimp-selection-load orig-channel)
	(gimp-selection-invert image)	
	(gimp-edit-clear drops-layer)
	(gimp-selection-none image)    
	(gimp-image-set-active-layer image temp-layer)
	(set! img-layer (car (gimp-image-merge-down image temp-layer EXPAND-AS-NECESSARY)))
	(gimp-drawable-set-name img-layer "img-layer")
	(gimp-selection-layer-alpha img-layer)
	(gimp-edit-fill img-layer BACKGROUND-FILL)    	
	
;;;;create channel
	(gimp-selection-save image)
	(set! img-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity img-channel 100)	
	(gimp-drawable-set-name img-channel "img-channel")
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image img-channel 15 15)

;;;;create the effects
	(gimp-image-set-active-layer image img-layer)
	
;;;;LIGHT 1
(plug-in-lighting 1 
	    image              ; IMAGE
		img-layer          ; DRAWABLE
		img-channel        ; BUMP MAP  (set to 0 if disabled)
		0                  ; ENVIRONMENT MAP  (set to 0 if disabled)
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		3                  ; TYPE OF MAPPING (0=linear,1=log, 2=sinusoidal, 3=spherical)
		1                  ; TYPE OF LIGHTSOURCE (0=point,1=directional,3=spot,4=none) 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		-1                 ; LIGHTSOURCE POS X
		-1                 ; LIGHTSOURCE POS Y
		1                  ; LIGHTSOURCE POS Z
		1.87               ; LIGHTSOURCE DIR X
		-1.52              ; LIGHTSOURCE DIR Y
		1                  ; LIGHTSOURCE DIR Z
		0.50               ; AMBIANT INTENSITY (GLOWING)
		0.30               ; DIFFUSE INTENSITY (BRIGHT)
		1                  ; DIFFUSE REFLECTIVITY (INTENSITY)
		0.5                ; SPECULAR REFLECTIVITY (SHINY)
		10                 ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT 

;;;;LIGHT 2
(plug-in-lighting 1 
	    image              ; IMAGE
		img-layer          ; DRAWABLE
		img-channel        ; BUMP MAP (USE '0' IF NOT NEEDED)
		0                  ; ENVIRONMENT MAP (USE '0' IF NOT NEEDED)
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		3                  ; TYPE OF MAPPING (0=linear,1=log, 2=sinusoidal, 3=spherical)
		1                  ; TYPE OF LIGHTSOURCE (0=point,1=directional,3=spot,4=none) 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		2                  ; LIGHTSOURCE POS X
		-1                 ; LIGHTSOURCE POS Y
		1                  ; LIGHTSOURCE POS Z
		-1.57              ; LIGHTSOURCE DIR X
		1.51               ; LIGHTSOURCE DIR Y
		1                  ; LIGHTSOURCE DIR Z
		0.50               ; AMBIANT INTENSITY (GLOWING)
		0.30               ; DIFFUSE INTENSITY (BRIGHT)
		1                  ; DIFFUSE REFLECTIVITY (INTENSITY)
		0.5                ; SPECULAR REFLECTIVITY (SHINY)
		10                 ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT 

    (plug-in-colortoalpha RUN-NONINTERACTIVE image img-layer '(135 135 135))              ;'(130 130 130));;828282
    (plug-in-blur RUN-NONINTERACTIVE image img-layer)
	(gimp-image-set-active-layer image bkg-layer)
	(plug-in-displace RUN-NONINTERACTIVE image bkg-layer 8 8 TRUE TRUE img-channel img-channel 0)

;;;;create the shadow
(if (> shadow-size 0)
  (begin
    (gimp-context-set-foreground '(0 0 0))  
	(set! shadow-layer (car (gimp-layer-new image width height RGBA-IMAGE "Shadow" shadow-opacity NORMAL-MODE)))
    (gimp-image-add-layer image shadow-layer -1)	
	(gimp-edit-fill shadow-layer FOREGROUND-FILL)
	(gimp-layer-translate shadow-layer shadow-size shadow-size)
	(gimp-layer-resize-to-image-size shadow-layer)
	(gimp-edit-clear shadow-layer)
	(gimp-selection-invert image)
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image shadow-layer 10 10)
	
   )
 )
    
	(gimp-selection-load orig-channel)
	
;;;;finish the script	
	(if (= conserve FALSE) 
	(begin
	(set! waterdrops-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
    (gimp-drawable-set-name waterdrops-layer "Water Drops")))
    (if (= keep-selection FALSE) (gimp-selection-none image))
	(gimp-image-remove-channel image orig-channel)
	(gimp-image-remove-channel image img-channel)
	(if (and (= conserve FALSE) (= alpha FALSE) (gimp-layer-flatten waterdrops-layer)))	
	
	
	
	
	
	
	
    
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)
    



 )
) 



(script-fu-register "script-fu-waterdrops"        		    
                    "Waterdrops"
                     "Creates Waterdrops over an Image"
                    "Graechan"
                    "Graechan"
                    "February 2012"
                    "RGB* GRAY*"
                    SF-IMAGE      "image"      0
                    SF-DRAWABLE   "drawable"   0
                    SF-ADJUSTMENT "Water drops size" '(86 1 172 1 10 0 0)
                    SF-ADJUSTMENT "Shadow Size" '(8 0 16 1 10 0 0)
                    SF-ADJUSTMENT "Shadow Opacity" '(100 0 100 1 10 0 0)
					SF-TOGGLE     "Keep selection"          FALSE
                    SF-TOGGLE     "Keep the Layers"   FALSE
)

(script-fu-menu-register "script-fu-waterdrops" "<Image>/Script-Fu/Effects/")


