; Dbut du script-fu Writing_In_The_Sand_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Logos > Writing In The Sand...
;               File > Create > Logos > Writing In The Sand...
;
;
;  adaptation du didacticiel vido "Writing_In_The_Sand" de DavidWoodFX sur :  http://www.youtube.com/watch?v=AC13I91213M&feature=player_embedded#at=360
;                                                                              http://gimppimp.tk/topics/246
; 
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; version 1.0 par samj (www.aljacom.com/~gimp) 2010/12/27
; version 2.0 par samj (www.aljacom.com/~gimp) 2010/12/27 pour gimp 2.7.2
; mise  jour le 23 aot 2011 pour compatibilit avec Gimp 2.7.3
; mise  jour le 7 mai 2012 pour  Gimp 2.8.0
;
; --------------------------------------------------------------------
;
;

(define (
				Writing_In_The_Sand
				Texte
				Police
				Taille_Police
				Contour
				Couleur_du_sable
				intensite
				decalage
				Brosse_contour

		)


	(set! Contour (/ Contour 100))
		
	(let*
		(
			; affectation des variables			
			
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser brosse
			(old-brush (car (gimp-context-get-brush)))


			; caractristiques de la surface occupe par le texte
			(fond_texte (gimp-text-get-extents-fontname Texte Taille_Police 0 Police))
			
			; dimensions du rsultat = largeur texte +  (Contour *largeur texte) , hauteur texte +  (Contour *hauteur texte)
			; largeur de la future image
			(width (+ (car fond_texte) (* Contour (car fond_texte)))) 
			
			; hauteur de la future image
			(height (+ (cadr fond_texte) (* Contour (cadr fond_texte)))) 
			
			; crer une nouvelle image rgb
			(img (car (gimp-image-new width height 0)))
			
			; calque fond
			(calque_fond)
			
			; calque texte
			(calque_texte)

			; calque texte 2
			(calque_texte_2)

			; calque texte 3
			(calque_texte_3)

			; chemin_texte
			(chemin_texte)
			(chemin_texte_2)
			(chemin_texte_3)

			
		)

	;; Start undo group.
	(gimp-image-undo-group-start img)		
		
		

		

; calque_fond********************************************************************************
	
	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img width height 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond -1 0)

	; choisir Couleur_du_sable pp
	(gimp-context-set-foreground Couleur_du_sable)
	
	; remplir de Couleur_du_sable
	(gimp-drawable-fill calque_fond 0)
	
	; ajouter du bruit
	(plug-in-rgb-noise 
				1 ; run-mode 
				img ; image 
				calque_fond ; drawable 
				0 ; independent 
				0 ; correlated 
				0.15 ; noise-1 
				0.15 ; noise-2 
				0.15 ; noise-3 
				0.15 ; noise-4
	)

	; appliquer un flou gaussien
	(plug-in-gauss 1 img calque_fond 1 1 1)
	
	; bumpmap
	(plug-in-bump-map 
				1 ; run-mode 
				img ; image 
				calque_fond ; drawable 
				calque_fond ; bumpmap 
				135 ; azimuth 
				45 ; elevation 
				1 ; depth 
				0 ; xofs 
				0 ; yofs 
				0 ; waterlevel 
				0 ; ambient 
				1 ; compensate 
				1 ; invert 
				0 ; type
	)




; calque Texte *******************************************************************************	

	; choisir noir pp
	(gimp-context-set-foreground '(0 0 0))
	
	; crer le calque texte
	;                  (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
	(set! calque_texte (car (gimp-text-fontname img -1 (/ (* Contour (car fond_texte)) 2) (/ (* Contour (cadr fond_texte)) 2) Texte 0 TRUE Taille_Police 0 Police)))
	
	; donner un nom au calque
	(gimp-item-set-name calque_texte "Texte")
	


;******
	; activer le contour du texte avec une brosse
	(if 
		(= Brosse_contour TRUE)
			(begin
			
				; crer un chemin  partir du texte
				(set! chemin_texte (car (gimp-vectors-new-from-text-layer img calque_texte)))
	
				; ajouter le chemin  l'image
				(gimp-image-insert-vectors img chemin_texte 0 0)

				; calque texte aux dimensions de l'image
				(gimp-layer-resize-to-image-size calque_texte)

				
				; opacit  100
				(gimp-context-set-opacity 100)
				
				; dterminer la taille des la brosse Circle Fuzzy en fonction de la Police
				(gimp-context-set-brush "Circle Fuzzy (03)") ; 5*5
				
				(if (> Taille_Police 70) 
					(begin
						(gimp-context-set-brush "Circle Fuzzy (05)")
					)
				) ; 7*7
				
				
				(if (> Taille_Police 90) 
					(begin
						(gimp-context-set-brush "Circle Fuzzy (07)")
					)
				) ;  9*9
				
				
				(if (> Taille_Police 110) 
					(begin
						(gimp-context-set-brush "Circle Fuzzy (09)")
					)
				) ; 11*11
				
				
				(if (> Taille_Police 130) 
					(begin
						(gimp-context-set-brush "Circle Fuzzy (11)")
					)
				) ; 13*13
				
				
				(if (> Taille_Police 150)
					(begin				
						(gimp-context-set-brush "Circle Fuzzy (13)")
					)
				) ; 15*15
				
				
				(if (> Taille_Police 170) 
					(begin
						(gimp-context-set-brush "Circle Fuzzy (15)")
					)
				) ; 17*17
				
				
				(if (> Taille_Police 190) 
					(begin
						(gimp-context-set-brush "Circle Fuzzy (17)")
					)
				) ; 19*19
				
				
				(if (> Taille_Police 210) 
					(begin
						(gimp-context-set-brush "Circle Fuzzy (19)")
					)
				) ; 21*21


	
				; dessiner avec la brosse animated Confetti
				(gimp-edit-stroke-vectors calque_texte chemin_texte)
				
		)
	)
	

;******

	; calque texte aux dimensions de l'image
	(gimp-layer-resize-to-image-size calque_texte)

	
	; ajuster niveaux
	(gimp-levels 
				calque_texte ; drawable 
				4 ; channel 
				53 ; low-input 
				242 ; high-input 
				1 ; gamma 
				0 ; low-output 
				255 ; high-output
	)
	


; calque Texte 2 *******************************************************************************	

	; choisir noir pp
	(gimp-context-set-foreground '(0 0 0))
	
	; crer le calque texte
	;                  (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
	(set! calque_texte_2 (car (gimp-text-fontname img -1 (/ (* Contour (car fond_texte)) 2) (/ (* Contour (cadr fond_texte)) 2) Texte 0 TRUE Taille_Police 0 Police)))

	; donner un nom au calque
	(gimp-item-set-name calque_texte_2 "Texte 2")

	; activer le contour du texte avec une brosse
	(if 
		(= Brosse_contour TRUE)
			(begin
			
				; crer un chemin  partir du texte
				(set! chemin_texte_2 (car (gimp-vectors-new-from-text-layer img calque_texte_2)))
	
				; ajouter le chemin  l'image
				(gimp-image-insert-vectors img chemin_texte_2 0 0)
				
				; opacit  100
				(gimp-context-set-opacity 100)
	
				; dessiner avec la brosse
				(gimp-edit-stroke-vectors calque_texte chemin_texte_2)
				
		)
	)

	; ajuster niveaux
	(gimp-levels 
				calque_texte_2 ; drawable 
				4 ; channel 
				53 ; low-input 
				242 ; high-input 
				1 ; gamma 
				0 ; low-output 
				255 ; high-output
	)

	; calque texte aux dimensions de l'image
	(gimp-layer-resize-to-image-size calque_texte_2)

	; bruit
	(if 
		(= Brosse_contour TRUE)
		
			; appliquer bruit spread
			(plug-in-spread 
						1 ; run-mode 
						img ; image 
						calque_texte_2 ; drawable 
						(/ Taille_Police 4) ; spread-amount-x 
						(/ Taille_Police 4) ; spread-amount-y
			)
			;else
			; appliquer bruit spread
			(plug-in-spread 
						1 ; run-mode 
						img ; image 
						calque_texte_2 ; drawable 
						(/ Taille_Police 7) ; spread-amount-x 
						(/ Taille_Police 7) ; spread-amount-y
			)	
	)
	
	

; calque Texte 3 *******************************************************************************	

	; choisir noir pp
	(gimp-context-set-foreground '(0 0 0))
	
	; crer le calque texte
	;                  (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
	(set! calque_texte_3 (car (gimp-text-fontname img -1 (/ (* Contour (car fond_texte)) 2) (/ (* Contour (cadr fond_texte)) 2) Texte 0 TRUE Taille_Police 0 Police)))

	; donner un nom au calque
	(gimp-item-set-name calque_texte_3 "Texte 3")

	; activer le contour du texte avec une brosse
	(if 
		(= Brosse_contour TRUE)
			(begin
			
				; crer un chemin  partir du texte
				(set! chemin_texte_3 (car (gimp-vectors-new-from-text-layer img calque_texte_3)))
	
				; ajouter le chemin  l'image
				(gimp-image-insert-vectors img chemin_texte_3 0 0)
				
				; opacit  100
				(gimp-context-set-opacity 100)
	
				; dessiner avec la brosse
				(gimp-edit-stroke-vectors calque_texte chemin_texte_3)
				
		)
	)
	
; ajuster niveaux
	(gimp-levels 
				calque_texte_3 ; drawable 
				4 ; channel 
				53 ; low-input 
				242 ; high-input 
				1 ; gamma 
				0 ; low-output 
				255 ; high-output
	)

	
	; calque texte aux dimensions de l'image
	(gimp-layer-resize-to-image-size calque_texte_3)

	; bruit
	(if 
		(= Brosse_contour TRUE)
		
			; appliquer bruit spread
			(plug-in-spread 
						1 ; run-mode 
						img ; image 
						calque_texte_3 ; drawable 
						(/ Taille_Police 2) ; spread-amount-x 
						(/ Taille_Police 2) ; spread-amount-y
			)
			;else
			; appliquer bruit spread
			(plug-in-spread 
						1 ; run-mode 
						img ; image 
						calque_texte_3 ; drawable 
						(/ Taille_Police 4) ; spread-amount-x 
						(/ Taille_Police 4) ; spread-amount-y
			)	
	)
	



; effet *******************************************************************************	


	
	; obtenir une slection  partir du texte
	(gimp-image-select-item img 0 calque_texte)
	
	; slection vers chemin
	(plug-in-sel2path 1 img calque_texte)
	
	; supprimer le contenu de la slection sur les calques calque_texte_2 et calque_texte_3
	(gimp-edit-clear calque_texte_2)
	(gimp-edit-clear calque_texte_3)

	; ne rien slectionner
	(gimp-selection-none img)
	
	; bumpmap le sable, source = calque_texte
	(plug-in-bump-map 
				1 ; run-mode 
				img ; image 
				calque_fond ; drawable 
				calque_texte ; bumpmap 
				135 ; azimuth 
				45 ; elevation 
				1 ; depth 
				0 ; xofs 
				0 ; yofs 
				255 ; waterlevel 
				0 ; ambient 
				1 ; compensate 
				0 ; invert 
				0 ; type
	)	


	; bumpmap le sable, source = calque_texte_2
	(plug-in-bump-map 
				1 ; run-mode 
				img ; image 
				calque_fond ; drawable 
				calque_texte_2 ; bumpmap 
				135 ; azimuth 
				45 ; elevation 
				1 ; depth 
				0 ; xofs 
				0 ; yofs 
				255 ; waterlevel 
				0 ; ambient 
				1 ; compensate 
				1 ; invert 
				0 ; type
	)


	; bumpmap le sable, source = calque_texte_3
	(plug-in-bump-map 
				1 ; run-mode 
				img ; image 
				calque_fond ; drawable 
				calque_texte_3 ; bumpmap 
				135 ; azimuth 
				55 ; elevation 
				intensite ; depth 
				decalage ; xofs 
				decalage ; yofs 
				255 ; waterlevel 
				0 ; ambient 
				1 ; compensate 
				1 ; invert 
				0 ; type
	)


	; visibilit des calques texte  0
	(gimp-item-set-visible calque_texte FALSE)
	(gimp-item-set-visible calque_texte_2 FALSE)
	(gimp-item-set-visible calque_texte_3 FALSE)
	
	
;*******************************************************************************************
	

	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
	
	; restaurer brosse
	(gimp-context-set-brush old-brush)
    
	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	;; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)

(script-fu-register
	"Writing_In_The_Sand"
	"<Image>/File/Create/Logos/Writing In The Sand..."
	"Ecrire sur du sable / Writing In The Sand "
	"samj"
	"samj"
	"2010-12-27"
	""
	SF-STRING "Text " "Gimp 2.8"
	SF-FONT "Font " "Serif Bold" ; Serif Bold
	SF-ADJUSTMENT "Font Size [pixels] " '(72 12 400 1 10 0 1) ; limitation  400 suite aux paramtres de spread
	SF-ADJUSTMENT "Contour [%] " '(38 10 500 1 10 0 1)
	SF-COLOR "Sand color " '(190 171 88) ; beab58
	SF-ADJUSTMENT "Intensity " '(1 0 5 1 10 0 1)
	SF-ADJUSTMENT "Offset " '(-1 -5 5 1 10 0 1)
	SF-TOGGLE "Outline Brush  "    TRUE

)

; FIN du script