
; Xmas-ornament-2.6 Rel. 0.3 Created by Graechan
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
; ------------
;| Change Log |
; ------------
; Rel 0.01 - Initial Release
; Rel 0.02 - Canged code to function with RobA's final release of Filltrans and incorporated It's additional features
; Thanks to Rob Antonishen for the Flood-Fill-Transparency script and for Photomaster's tutorial
; that made witing this script so much easier.
; This version is for 2.6 but will function on 2.8
; Rel 0.03 - Changed code to incorporate RobA's Filltrans and Added some Bugfixes
;;;;
(define (script-fu-xmas-ornament image drawable
                                       conserve
                              fill
                              in-dist
                              opacity)
                                 
                      

(let* (
            ;(image (car (gimp-image-duplicate inImage)))
         (ornament-layer (car (gimp-image-get-active-layer image)))
         (width (car (gimp-image-width image)))
         (height (car (gimp-image-height image)))
         (ball-layer 0)
         (ring-layer 0)
            (cap-layer 0)
         (cap1-layer 0)
         (cap2-layer 0)
         (blank-layer 0)
         (bkg-layer 0)
         (brushName 0)
         (image-layer 0)
         (dist (* in-dist 5))
         (opacity-layer 0)         
        )
   (gimp-context-push)
    (gimp-image-undo-group-start image)
   (gimp-context-set-foreground '(0 0 0))
   (gimp-context-set-background '(255 255  255))
   
;;;;Add alpha layer to image   
   (gimp-layer-add-alpha ornament-layer)
   
;;;;square up the Image   
    (if (< height width) (set! width height))
   (if (< width height) (set! height width))
   (gimp-image-scale-full image 1000 1000 2)
   
   
   (gimp-drawable-set-name ornament-layer "Ornament")
   (gimp-layer-scale ornament-layer 500 1000 TRUE)
   (gimp-layer-resize-to-image-size ornament-layer)
   (set! ball-layer (car (gimp-layer-copy ornament-layer TRUE)))
   (gimp-image-add-layer image ball-layer -1)
   (gimp-drawable-set-name ball-layer "Ball")
   
   
   (plug-in-map-object RUN-NONINTERACTIVE image ball-layer
         1             ; mapping sphere
         0.5 0.5 2.0      ; viewpoint
         0.5 0.5 0.5      ; object pos
         1.0 0.0 0.0      ; first axis
         0.0 1.0 0.0      ; 2nd axis
         0.0 0.0 0.0      ; axis rotation
         2 '(255 255 255); light (type, color)
         -0.5 -0.5 2      ; light position
         -1.0 -1.0 1.0   ; light direction
         0.3 1 0.5 0.3 27; material (amb, diff, refl, spec, high)
         TRUE      ; antialias
         FALSE       ; tile
         FALSE       ; new image
         TRUE       ; transparency
         0.225        ; radius
         1 1 1 1    ; unused parameters
         -1 -1 -1 -1 ; unused parameters
         -1 -1 -1 -1); unused parameters
   (gimp-layer-scale ornament-layer 250 500 TRUE)
   (gimp-layer-set-offsets ornament-layer 369 108)
   
   (gimp-context-set-foreground '(127 127 127))
;;;;create the ring-layer   
   (set! ring-layer (car (gimp-layer-new image 1000 1000 RGBA-IMAGE "Ring" 100 NORMAL-MODE)))
    (gimp-image-add-layer image ring-layer -1)
   (gimp-drawable-fill ring-layer FOREGROUND-FILL)
   (plug-in-rgb-noise RUN-NONINTERACTIVE image ring-layer FALSE FALSE 0.3 0.3 0.3 0)
   (plug-in-wind RUN-NONINTERACTIVE image ring-layer 10 0 10 0 0)
   
   (set! cap1-layer (car (gimp-layer-copy ring-layer TRUE)))
   (gimp-image-add-layer image cap1-layer -1)
   (gimp-drawable-set-name cap1-layer "Cap1")
   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;start of Mathmap   
   (plug-in-mathmap RUN-NONINTERACTIVE image cap1-layer 1 1 0 "filter FromNadirZenith (image in)

# Filter created by Seb Przd

# Licensed under the GPL



output=1;

if y>Y/4 then

sinphi1=1;

xc=-X/2;

else if y<-Y/4 then

sinphi1=-1;

xc=X/2;

else

output=0;

end;

end;



cosc=sinphi1*sin(y/Y*pi/2);

xx=cos(y/Y*pi/2)*sin(x/X*pi)/cosc;

yy=-sinphi1*cos(y/Y*pi/2)*cos(x/X*pi)/cosc;



if abs(xx)>1 then output=0; end;



if output then

in(xy:[xx*X/2+xc,yy*Y])

else

rgbaColor(0,0,0,0)

end



end")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;end of mathmap   
   
    (gimp-rect-select image 0 500 1000 500 0 FALSE 0)   
   (gimp-edit-clear cap1-layer)
   (gimp-selection-none image)
   (gimp-layer-scale cap1-layer 500 1000 FALSE)
   (gimp-layer-resize-to-image-size cap1-layer)
   
   (set! cap2-layer (car (gimp-layer-copy cap1-layer TRUE)))
   (gimp-image-add-layer image cap2-layer -1)
   (gimp-drawable-set-name cap2-layer "Cap2")
   (gimp-drawable-transform-flip-simple cap2-layer 0 TRUE 500 TRUE)
   
   ;;;;;;;
   (set! cap-layer (car (gimp-image-merge-down image cap2-layer EXPAND-AS-NECESSARY)))
   (gimp-drawable-set-name cap-layer "Cap")
   
   (set! blank-layer (car (gimp-layer-new image 1000 1000 RGBA-IMAGE "Blank" 100 NORMAL-MODE)))
    (gimp-image-add-layer image blank-layer -1)
   
   (plug-in-map-object RUN-NONINTERACTIVE image cap-layer
         3             ; mapping
         0.5 0.5 2.0      ; viewpoint
         0.5 0.5 0.0      ; object pos
         1.0 0.0 0.0      ; first axis
         0.0 1.0 0.0      ; 2nd axis
         0.0 0.0 0.0      ; axis rotation
         2 '(255 255 255)   ; light (type, color)
         -0.5 -0.5 2      ; light position
         -1.0 -1.0 1.0   ; light direction
         0.3 1 0.5 0.3 27   ; material (amb, diff, refl, spec, high)
         TRUE      ; antialias
         FALSE       ; tile
         FALSE       ; new image
         TRUE       ; transparency
         0.06        ; radius
         1 1 1        ; unused parameters
         0.30        ; length
         -1 -1 -1    ; unused parameters
         -1 -1 -1    ; unused parameters
         cap-layer   ;cylinder top
         blank-layer);cylinder bottem
   
   (gimp-image-set-active-layer image cap-layer)
   (plug-in-autocrop-layer RUN-NONINTERACTIVE image cap-layer)
   (gimp-layer-set-offsets cap-layer 438 110)

;;;;build the ring-layer image   
   (gimp-context-set-gradient "Golden")
   (plug-in-gradmap RUN-NONINTERACTIVE image ring-layer)
   (gimp-selection-layer-alpha ball-layer)
    (gimp-selection-shrink image 259);size of ring
   (gimp-selection-invert image)
    (gimp-edit-clear ring-layer)
    (gimp-selection-invert image)
   (gimp-selection-shrink image 4);width of ring
   (gimp-edit-clear ring-layer)
   (gimp-selection-none image)
   (gimp-image-set-active-layer image ring-layer)
   (plug-in-autocrop-layer RUN-NONINTERACTIVE image ring-layer)
   (gimp-layer-set-offsets ring-layer 456 30)

;;;;remove unwanted layers   
   (gimp-image-remove-layer image ornament-layer)
   (gimp-image-remove-layer image blank-layer)
   
;;;;create bkg-layer   
   (set! bkg-layer (car (gimp-layer-copy ball-layer TRUE)))
   (gimp-image-add-layer image bkg-layer 4)
   (gimp-drawable-set-name bkg-layer "Background")
   (gimp-layer-set-opacity bkg-layer opacity)
   
;;;;fill background transparency if needed   
   (if (= fill TRUE) (the-filltrans image bkg-layer 10 dist FALSE))

;;;;create the lighting effect using 'gradient flare'
    (if (= fill TRUE) (plug-in-gflare 1 image bkg-layer "Bright_Star" 500 500 426 0 0 60 1 FALSE 3 0.20))



   
;;;;create layer for opacity if needed   
   (if (and (= fill TRUE) (< opacity 100))
        (begin   
   (set! opacity-layer (car (gimp-layer-new image 1000 1000 RGBA-IMAGE "Opacity" 100 NORMAL-MODE)))
   (gimp-image-add-layer image opacity-layer 5)
   (gimp-context-set-background '(255 255  255))
   (gimp-selection-layer-alpha bkg-layer)
   (gimp-selection-shrink image 1)
   (gimp-edit-fill opacity-layer BACKGROUND-FILL)
   (plug-in-gauss 1 image opacity-layer 5 5 0)
   (gimp-selection-none image)
   (set! bkg-layer (car (gimp-image-merge-down image bkg-layer EXPAND-AS-NECESSARY)))
   (gimp-drawable-set-name bkg-layer "Background")
       )
   )   

;;;;merge layers if needed
   (if (= conserve FALSE)
      (begin
   (set! cap-layer (car (gimp-image-merge-down image cap-layer EXPAND-AS-NECESSARY)))   
   (gimp-image-set-active-layer image ball-layer)
   (set! image-layer (car (gimp-image-merge-down image cap-layer EXPAND-AS-NECESSARY)))
   (gimp-drawable-set-linked image-layer TRUE)
   (gimp-drawable-set-linked bkg-layer TRUE)
   (set! image-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
   (gimp-drawable-set-name image-layer "Xmas Ornament")
        )
   )   
      
   (gimp-image-scale-full image width height 2)
   
;;;;finish up   
   (gimp-image-undo-group-end image)
   (gimp-context-pop)
    (gimp-displays-flush)
   
)
)

(script-fu-register "script-fu-xmas-ornament"                 
                    "Xmas-Ornament..."
                     "xmas-ornament-will turn an RGB image into a Christmas bauble. Will require MathMap go here for additional mathmap file http://photocomix-resources.deviantart.com/art/MathMap-custom-script-2-1-83507321?q=sort%3Atime+favby%3Anevit&qo=76
(Install instructions included),"
                    "Graechan"
                    "Graechan - http://gimpchat.com"
                    "Dec 2013"
                    "RGB*"
                    SF-IMAGE      "image"      0
                    SF-DRAWABLE   "drawable"   0
                    SF-TOGGLE _"Keep layers?" FALSE
               SF-TOGGLE _"Fill Background" FALSE
               SF-ADJUSTMENT _"Distance (0 for full layer)" '(0 0 100 1 10 0 0)
               SF-ADJUSTMENT _"Opacity of Background" '(100 0 100 1 10 0 0)
)

(script-fu-menu-register "script-fu-xmas-ornament" "<Image>/Script-Fu/Map")


(define (script-fu-xmas-ornament-logo
                                      size
                                      text
                                      txt-color
                                      font
                                      font-size
                                      bkg-type
                                      pattern
                                      bkg-color
                             gradient
                             conserve
                             fill
                             dist
                             opacity)
  (let* (
         (width size)
         (height size)
         (offx 0)
         (offy 0)
         (image (car (gimp-image-new size size RGB)))
         
         (border (/ font-size 3))
         (text-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (text-width (car (gimp-drawable-width text-layer)))
         (text-height (car (gimp-drawable-height text-layer)))
         (bkg-layer 0)
       (final-layer 0)
         ;;(xmas-ornament 0)
         )
    (gimp-context-push)
   
;;;;centre text on line
   (gimp-text-layer-set-justification text-layer 2)
   
;;;;set the new Image size   
    (if (> text-width size)
           (begin
    (set! width text-width)
           )
    )
    (if (> text-height size)
           (begin
    (set! height text-height)
           )
    )
   
;;;;square up the Image   
    (if (< height width) (set! height width))
   (if (< width height) (set! width height))
   (gimp-image-resize image width height 0 0)
   
;;;;centre the text layer   
    (set! offx (/ (- width text-width) 2))
    (set! offy (/ (- height text-height) 2))   
    (gimp-layer-set-offsets text-layer offx offy)

;;;;set the text clolor   
    (gimp-context-set-foreground txt-color)
   (gimp-selection-layer-alpha text-layer)
   (gimp-edit-fill text-layer FOREGROUND-FILL)
   (gimp-selection-none image)

;;;;create the background layer   
   (set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 1)
   (gimp-context-set-pattern pattern)
   (gimp-context-set-background bkg-color)
   (gimp-context-set-gradient gradient)
   (if (= bkg-type 0) (gimp-drawable-fill bkg-layer PATTERN-FILL))      
    (if (= bkg-type 1) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))
   (if (= bkg-type 2) (gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-CONICAL-SYMMETRIC 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE (/ width 2) (/ height 2) width height));; GRADIENT-LINEAR
   
;;;;resize the text-layer      
    (gimp-image-set-active-layer image text-layer)
   (gimp-layer-resize-to-image-size text-layer)
    (set! final-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
   (gimp-image-scale-full image size size 2)
;    (gimp-display-new image)

;;;;create the ornament   
   (gimp-image-undo-disable image)
   (script-fu-xmas-ornament image final-layer conserve fill dist opacity)
    (gimp-image-undo-enable image)
   
   
    ;(gimp-image-undo-enable image)
   (gimp-context-pop)
    (gimp-display-new image)
   (gimp-displays-flush)
    )
  )
(script-fu-register "script-fu-xmas-ornament-logo"
  "Xmas-Ornament-Logo..."
  "Create an image with a Xmas ornament using a pattern,color or gradient and text over the outside. Will require MathMap go here for additional mathmap file http://photocomix-resources.deviantart.com/art/MathMap-custom-script-2-1-83507321?q=sort%3Atime+favby%3Anevit&qo=76
(Install instructions included)"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "Dec 2013"
  ""
  SF-ADJUSTMENT _"Image Size (pixels)" '(1000 50 4000 1 10 0 1)
  SF-TEXT       _"Text"    "Merry\nXmas"
  SF-COLOR      _"Text color"         '(0 0 0)
  SF-FONT       _"Font"               "JasmineUPC Bold"
  SF-ADJUSTMENT _"Font size (pixels)" '(300 6 3500 1 1 0 1)
  SF-OPTION _"Background Type" '("Pattern" "Color" "Gradient")
  SF-PATTERN    _"Pattern"            "Blue Squares"
  SF-COLOR      _"Background color"         '(153 153 153)
  SF-GRADIENT   _"Background Gradient" "Abstract 3"
  SF-TOGGLE _"Keep layers?" FALSE
  SF-TOGGLE _"Fill Background" FALSE
  SF-ADJUSTMENT _"Distance (0 for full layer)" '(0 0 100 1 10 0 0)
  SF-ADJUSTMENT _"Opacity of Background" '(100 0 100 1 10 0 0)
  )
(script-fu-menu-register "script-fu-xmas-ornament-logo"
  "<Image>/File/Create/Logos"
  )

(define (the-filltrans img inLayer inStep inDist inTransfer)
  (let*
    ( 
      (inStep (/ inStep 2))
      (inDist (* inDist 5))
      (imgO img)
      (inLayerO inLayer)
      (img (car (gimp-image-duplicate img)))
      (inLayer (car (gimp-image-get-active-layer img)))
      (blurLayer (car (gimp-layer-copy inLayer TRUE)))
      (alphaVal 0)
      (blursize inStep)
      (alphasel 0)
      (alphaselO 0)
      (buffer "ftbuff")
      (inc 0)
    )
    ;  it begins here
    (gimp-context-push)   
    (gimp-image-undo-group-start imgO)

	(gimp-progress-init "Flooding out Colour" -1)
    
    (gimp-selection-layer-alpha inLayerO)
    (set! alphaselO (car (gimp-selection-save imgO)))
    (gimp-selection-none imgO)
    
    (gimp-selection-layer-alpha inLayer)
    (set! alphasel (car (gimp-selection-save img)))
    (gimp-selection-none img)
    
    (gimp-image-undo-disable img)    
    (gimp-image-add-layer img blurLayer (+ (car (gimp-image-get-layer-position img inLayer)) 1))

    (plug-in-threshold-alpha RUN-NONINTERACTIVE img inLayer 254)
    (plug-in-threshold-alpha RUN-NONINTERACTIVE img blurLayer 254)
    
    (while (< alphaVal 1)
      (gimp-selection-layer-alpha blurLayer)
      (gimp-selection-border img blursize)
      (gimp-selection-sharpen img)
      (if (equal? (car (gimp-selection-is-empty img)) FALSE)
        (plug-in-gauss RUN-NONINTERACTIVE img blurLayer blursize blursize 0)  
      )
      
      (if (= inDist 0)
        (begin
          (gimp-progress-update alphaVal)
          (gimp-progress-set-text (string-append "Flooding out Colour: " (number->string (floor (* alphaVal 100))) "%"))
        )
        (begin
          (gimp-progress-update (/ inc inDist))
          (gimp-progress-set-text (string-append "Flooding out Colour: " (number->string (floor (* (/ inc inDist) 100))) "%"))
        )
      )
        
      (gimp-levels blurLayer HISTOGRAM-ALPHA 0 128 1 0 255)
      (gimp-selection-none img)
      (set! alphaVal (list-ref (gimp-histogram blurLayer HISTOGRAM-ALPHA 255 255) 5))
      
      (set! inc (+ inc blursize))
      (if (and (> inDist 0) (> inc inDist))
        (set! alphaVal 1)
      )
      (set! blursize (+ blursize inStep))
    )
    
    (gimp-selection-layer-alpha inLayer)
    (gimp-selection-invert img)
    
    (plug-in-gauss RUN-NONINTERACTIVE img blurLayer (* inStep 2) (* inStep 2) 0)   
    
    (gimp-image-remove-layer img inLayer)
    
    (when (> inDist 0)
      (gimp-selection-load alphasel)
      (gimp-selection-grow img (/ inDist 5))
      (gimp-selection-invert img)
      (gimp-edit-clear blurLayer)
    )
    
    (gimp-selection-none img)     
    
    (set! buffer (car (gimp-edit-named-copy blurLayer buffer)))  
    (gimp-floating-sel-anchor (car (gimp-edit-named-paste inLayerO buffer TRUE)))
    
    (gimp-image-delete img) 
     
    (when (equal? inTransfer TRUE)
      (gimp-selection-load alphaselO)
      (gimp-layer-add-mask inLayerO (car (gimp-layer-create-mask inLayerO ADD-SELECTION-MASK)))
      (gimp-selection-none imgO)
      (gimp-layer-set-edit-mask inLayerO FALSE)      
    )

    (gimp-image-remove-channel imgO alphaselO)

    (gimp-displays-flush)   	
    (gimp-image-undo-group-end imgO)

    (gimp-context-pop)
  )
)